//
//  ActivityIndicatorHelper.swift
//  CollectMe
//
//  Created by Oscar Fernandez Ardanuy on 15/05/16.
//  Copyright © 2016 dorhus. All rights reserved.
//

import Foundation
import UIKit

class ActivityIndicatorHelper {
    
    static func getActivityIndicator(view: UIView) -> UIActivityIndicatorView {
        let activityIndicator = UIActivityIndicatorView(activityIndicatorStyle: UIActivityIndicatorViewStyle.Gray)
        
        activityIndicator.hidesWhenStopped = true;
        activityIndicator.activityIndicatorViewStyle  = UIActivityIndicatorViewStyle.Gray;
        activityIndicator.center = view.center;
        
        view.addSubview(activityIndicator)
        
        return activityIndicator
    }
    
    static func startActivityIndicator(indicator: UIActivityIndicatorView?) {
        UIApplication.sharedApplication().beginIgnoringInteractionEvents()
        indicator?.startAnimating()
    }
    
    static func stopActivityIndicator(indicator: UIActivityIndicatorView?) {
        // Detiene el indicador de proceso en marcha
        UIApplication.sharedApplication().endIgnoringInteractionEvents()
        indicator?.stopAnimating()
    }
    
}