//
//  ColorPickerCNCTVCExt.swift
//  CollectMe
//
//  Created by Oscar Fernandez Ardanuy on 03/06/16.
//  Copyright © 2016 dorhus. All rights reserved.
//

import Foundation
import UIKit

extension CollectionsNewCollectionTableViewController: UIPickerViewDataSource, UIPickerViewDelegate {
    
    func numberOfComponentsInPickerView(pickerView: UIPickerView) -> Int {
        return 1
    }
    
    func pickerView(pickerView: UIPickerView, numberOfRowsInComponent component: Int) -> Int {
        return CollectionsColor.colors.count
    }
    
    func pickerView(pickerView: UIPickerView, titleForRow row: Int, forComponent component: Int) -> String? {
        return NSLocalizedString(CollectionsColor.colors[row], comment: "")
    }
    
    func pickerView(pickerView: UIPickerView, didSelectRow row: Int, inComponent component: Int) {
        self.selectedColor = CollectionsColor.colors[row]
    }
    
    internal func setUpColorsPicker() {
        
        if (self.myCollection?.color != nil) {
            if let colorIndex:Int = CollectionsColor.colors.indexOf((self.myCollection?.color!)!) {
                self.colorPickerView.selectRow(colorIndex, inComponent: 0, animated: true)
            }
        }
    }
}
