//
//  InfoTableViewController.swift
//  CollectMe
//
//  Created by Oscar Fernandez Ardanuy on 13/05/16.
//  Copyright © 2016 dorhus. All rights reserved.
//

import UIKit

class InfoTableViewController: UITableViewController {
    
    @IBOutlet weak var nCollectionsLabel: UILabel!
    @IBOutlet weak var nItemsLabel: UILabel!
    @IBOutlet weak var nWantedItemsLabel: UILabel!
    
    // data
    var numberOfCollections: Int = 0
    var numberOfItems: Int = 0
    var numberOfWantedItems: Int = 0
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Uncomment the following line to preserve selection between presentations
        // self.clearsSelectionOnViewWillAppear = false

        // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
        // self.navigationItem.rightBarButtonItem = self.editButtonItem()
        setSyle()
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    override func viewWillAppear(animated: Bool) {
        
        // collections
        DataManager.getMyCollectionsCount { (nCollections: Int) -> (Void) in
            self.numberOfCollections = nCollections
            
            let cMarkIndex = self.nCollectionsLabel.text?.characters.indexOf(":")
            self.nCollectionsLabel.text = self.nCollectionsLabel.text?.substringToIndex(cMarkIndex!)
            self.nCollectionsLabel.text?.appendContentsOf(": \(self.numberOfCollections)")
        }
        
        // items
        DataManager.getMyItemsCount { (nItems: Int) -> (Void) in
            self.numberOfItems = nItems
            
            let iMarkIndex = self.nItemsLabel.text?.characters.indexOf(":")
            self.nItemsLabel.text = self.nItemsLabel.text?.substringToIndex(iMarkIndex!)
            self.nItemsLabel.text?.appendContentsOf(": \(self.numberOfItems)")
        }
        
        // wanted items
        DataManager.getMyWishedItemsCount { (nItems: Int) -> (Void) in
            self.numberOfWantedItems = nItems
            
            let wMarkIndex = self.nWantedItemsLabel.text?.characters.indexOf(":")
            self.nWantedItemsLabel.text = self.nWantedItemsLabel.text?.substringToIndex(wMarkIndex!)
            self.nWantedItemsLabel.text?.appendContentsOf(": \(self.numberOfWantedItems)")
        }
    }

}
