//
//  MessageHelper.swift
//  CollectMe
//
//  Created by Oscar Fernandez Ardanuy on 15/04/16.
//  Copyright © 2016 dorhus. All rights reserved.
//

import Foundation
import UIKit

class MessageHelper {
    
    static func showBasicAlert(title: String?, message: String, view: UIViewController) {
        //New alert
        let actionSheetController: UIAlertController = UIAlertController(title: title, message: message, preferredStyle: .Alert)
        //New OK button
        let okAction: UIAlertAction = UIAlertAction(title: NSLocalizedString("OK", comment: ""), style: .Default) { Void in}
        // Add OK button in alert
        actionSheetController.addAction(okAction)
        // show alert
        view.presentViewController(actionSheetController, animated: true, completion: nil)
    }
    
    static func showBasicAlertWithReturnBackNavigation(title: String?, message: String, view: UIViewController) {
        //New alert
        let actionSheetController: UIAlertController = UIAlertController(title: title, message: message, preferredStyle: .Alert)
        //New OK button
        let okAction: UIAlertAction = UIAlertAction(title: NSLocalizedString("OK", comment: ""), style: .Default) { Void in
            view.navigationController?.popViewControllerAnimated(true)
        }
        // Add OK button in alert
        actionSheetController.addAction(okAction)
        // show alert
        view.presentViewController(actionSheetController, animated: true, completion: nil)
    }
}