//
//  MyItem.swift
//  CollectMe
//
//  Created by Oscar Fernandez Ardanuy on 25/04/16.
//  Copyright © 2016 dorhus. All rights reserved.
//

import Foundation
import CoreData


class MyItem: NSManagedObject {

// Insert code here to add functionality to your managed object subclass

    func isWanted() -> Bool {
        let isWanted = wanted! as Bool
        return isWanted
    }
    
    func setIsWanted(isWanted: Bool) {
        wanted = isWanted
    }
    
    func hasBox() -> Bool {
        let hasBox = with_box! as Bool
        return hasBox
    }
    
    func setHasBox(hasBox: Bool) {
        with_box = hasBox
    }
    
    func isComplete() -> Bool {
        let isComplete = is_complete! as Bool
        return isComplete
    }
    
    func setIsComplete(isComplete: Bool) {
        is_complete = isComplete
    }
    
    func getImages() -> [PicturesThumbnail] {
        if (pictures != nil) {
            return pictures!.array as! [PicturesThumbnail]
        } else {
            return []
        }
    }
    
    func getBestImageThumbnail() -> NSData? {
        let allImages = getImages()
        var bestImage: NSData
        
        if !allImages.isEmpty {
            // best is first if not has other
            bestImage = allImages[0].image_data!
            // find best
            for oneImage in allImages {
                if oneImage.isBest() {
                    bestImage = oneImage.image_data!
                    break
                }
            }
            return bestImage
        }
        
        return nil
    }
    
}
