//
//  SearchILVExt.swift
//  CollectMe
//
//  Created by Oscar Fernandez Ardanuy on 11/05/16.
//  Copyright © 2016 dorhus. All rights reserved.
//

import Foundation
import UIKit

extension ItemsListViewController: UISearchResultsUpdating {
    
    internal func setupSearchBar() {
        searchController.searchResultsUpdater = self
        searchController.dimsBackgroundDuringPresentation = false
        searchController.searchBar.sizeToFit()
        definesPresentationContext = true
        self.tableView.tableHeaderView = searchController.searchBar
    }
    
    func updateSearchResultsForSearchController(searchController: UISearchController) {
        self.itemsSortedArray.removeAll(keepCapacity: false)
        filterContentForSearchText(searchController.searchBar.text!)
    }
    
    internal func filterContentForSearchText(searchText: String, scope: String = "All") {
        self.itemsSortedArray = self.allItemsSortedArray.filter({ (oneItem: MyItem) -> Bool in
            let similarTitle: Bool = oneItem.name_title!.lowercaseString.containsString(searchText.lowercaseString)
            let similarDescription: Bool = (oneItem.desc?.lowercaseString.containsString(searchText.lowercaseString))!
            let similarType: Bool = (oneItem.type_class?.lowercaseString.containsString(searchText.lowercaseString))!
            
            return similarTitle || similarDescription || similarType
        })
        
        self.tableView.reloadData()
        
    }
}