//
//  SavingImagesINITVC.swift
//  CollectMe
//
//  Created by Oscar Fernandez Ardanuy on 29/04/16.
//  Copyright © 2016 dorhus. All rights reserved.
//

import Foundation
import UIKit

extension ItemsNewItemTableViewController: UIImagePickerControllerDelegate, UINavigationControllerDelegate {
    
    internal func setUpImagePicker() {
        self.imagePicker = UIImagePickerController ()
        self.imagePicker!.delegate = self
    }
    
    internal func selectImageOriginOptionSheet() {
        let actionSheetController: UIAlertController = UIAlertController(title: nil, message: NSLocalizedString("Select origin", comment: ""), preferredStyle: .ActionSheet)
        
        // Cancel
        let cancelAction: UIAlertAction = UIAlertAction(title: NSLocalizedString("Cancel", comment: ""), style: .Cancel) { action -> Void in
            //do nothing
        }
        actionSheetController.addAction(cancelAction)
        
        // Photo
        if (UIImagePickerController.isSourceTypeAvailable(.Camera)) {
            let cameraAction: UIAlertAction = UIAlertAction(title: NSLocalizedString("Camera", comment: ""), style: .Default) { action -> Void in
                self.imagePicker?.sourceType = UIImagePickerControllerSourceType.Camera
                self.presentViewController(self.imagePicker!, animated: true, completion: nil)
            }
            actionSheetController.addAction(cameraAction)
        }
        
        // Library
        let libraryAction: UIAlertAction = UIAlertAction(title: NSLocalizedString("Gallery", comment: ""), style: .Default) { action -> Void in
            self.imagePicker?.sourceType = UIImagePickerControllerSourceType.PhotoLibrary
            self.presentViewController(self.imagePicker!, animated: true, completion: nil)
        }
        actionSheetController.addAction(libraryAction)
        
        self.presentViewController(actionSheetController, animated: true, completion: nil)
    }
    
    func imagePickerController(picker: UIImagePickerController, didFinishPickingImage image: UIImage, editingInfo: [String : AnyObject]?) {
        // do nothing
    }
    
    // when image is selected
    func imagePickerController(picker: UIImagePickerController, didFinishPickingMediaWithInfo info: [String : AnyObject]) {
        if let pickedImage = info[UIImagePickerControllerOriginalImage] as? UIImage {
            prepareImageForSaving(pickedImage)
            printImagesInScrollView()
        }
        
        // return to the application
        dismissViewControllerAnimated(true, completion: nil)
    }
    
    func prepareImageForSaving(image:UIImage) {
        picturesArray.addNewPictureFrom(original: image)
    }
    
}
