//
//  UIImageExtensions.swift
//  CollectMe
//

import Foundation
import UIKit

extension UIImage {
    
    /**
     Scales the image to a target size
     
     - parameter newSize: the target size
     
     - returns: the scaled image
     */
    func scale(toSize newSize:CGSize) -> UIImage {
        
        // make sure the new size has the correct aspect ratio
        let aspectFill = self.size.resizeFill(newSize)
        
        UIGraphicsBeginImageContextWithOptions(aspectFill, false, 0.0);
        self.drawInRect(CGRectMake(0, 0, aspectFill.width, aspectFill.height))
        let newImage:UIImage = UIGraphicsGetImageFromCurrentImageContext()
        UIGraphicsEndImageContext()
        
        return newImage
    }
    
}
