//
//  Utils.swift
//  CollectMe
//
//  Created by Oscar Fernandez Ardanuy on 27/04/16.
//  Copyright © 2016 dorhus. All rights reserved.
//

import Foundation
import UIKit

class Utils {
    static func getOrigin(navigationController: UINavigationController!) -> MyTabBarOrigin {
        if (navigationController.isKindOfClass(CollectionsNavigationController)) {
            return MyTabBarOrigin.CollectionsList
        } else if (navigationController.isKindOfClass(WantedNavigationController)) {
            return MyTabBarOrigin.Wanted
        } else if (navigationController.isKindOfClass(SearchNavigationController)) {
            return MyTabBarOrigin.Search
        } else if (navigationController.isKindOfClass(InformationNavigationController)) {
            return MyTabBarOrigin.Info
        } else {
            return MyTabBarOrigin.CollectionsList
        }
    }
    
    static func NSDataToUIImage(image: NSData) -> UIImage? {
        if let smallImage = UIImage(data: image, scale:1.0) {
            return smallImage
        }
        
        return nil
    }
    
}
